#include "font.h"

/* inherit attributes */
dtdtc_string_t
svg_font_font_family_inherit(dtdtc_context_t ctx, dtdtc_element_t element) {
  dtdtc_element_t parent;
  dtdtc_string_t *font_family;

  parent = dtdtc_lookup_parent_by_attribute(ctx, element, "font-family");

  if (parent) {
    font_family = dtdtc_attribute_get(ctx, parent, "font-family");
    if (*font_family) {
      dtdtc_attribute_set(ctx, "font-family", *font_family);
      return *font_family;
    } else {
      /* recurse on parent */
      return svg_font_font_family_inherit(ctx, parent);
    }
  }

  dtdtc_warning(ctx, "can't inherit font-family");
  return NULL;
}
