/*
 *
 */

#ifndef _IMAGE_FT_H_
#define _IMAGE_FT_H_

#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_GLYPH_H
#include FT_IMAGE_H
#include FT_CACHE_IMAGE_H

/*** IFT Pixbuf definition **********************/

typedef struct _IFT_Pixbuf {
  int w;			/* width of drawn image */
  int h;			/* height of drawn image */
  int aw;			/* width of allocated image */
  int ah;			/* height of allocated image */
  int rowlen;			/* line stride */
  int nchans;
  unsigned char * pixels;
} IFT_Pixbuf;

extern char IFT_Error[1024];

extern IFT_Pixbuf * 
IFT_PixbufNew(unsigned int w, unsigned int h, unsigned int nchans, unsigned char *col);

extern void
IFT_PixbufFree(IFT_Pixbuf * buf);


/*** IFT Definition **********************/
typedef struct _IFT {
  FT_Face     face;
  FT_Glyph    *glyphs;
  unsigned int num_glyphs;
  FT_Vector   *pos;

  char * text;
  int textlen;
  unsigned char bg[4];
  unsigned char fg[4];
  unsigned int charsize;
  unsigned int border;

  IFT_Pixbuf * pixbuf;
} IFT;

extern int IFT_Init(char **fontpath);
extern int IFT_Exit(void); 
extern IFT * IFT_New(char * font,char * style);
extern void IFT_Free(IFT * ift);
extern int IFT_SetBgColor(IFT * ift,
			  unsigned char r, unsigned char g,
			  unsigned char b, unsigned char a);
extern int IFT_SetFgColor(IFT * ift,
			  unsigned char r, unsigned char g,
			  unsigned char b, unsigned char a);
extern int IFT_SetSize(IFT * ift, unsigned int size, unsigned int border);
extern int IFT_SetText(IFT * ift, char * text);
extern int IFT_Render(IFT * ift);

#endif
