#include "svg-parser.h"

void
svg_image_start(dtdtc_context_t ctx) {
  svg_element_image_t image;
  image =  (svg_element_image_t)ctx->element;

  image->ih = ih_image_new(image, image->xlink_href);
  if ( !image->ih ) {
    dtdtc_warning(ctx, "can't create image handler");
    return;
  }
}

void
svg_image_destroy(dtdtc_context_t ctx) {

}

void
svg_image_draw(svg_element_image_t image) {
  ih_boolean_t updated;

  if (!ih_image_decodeframe(image->ih, 1, &updated))
    printf("error on ih_image_decodeframe\n");

  glEnable(GL_TEXTURE_2D);

  glPixelStorei(GL_UNPACK_ALIGNMENT, ih_image_alignment(image->ih));
  glPixelStorei(GL_UNPACK_ROW_LENGTH, ih_image_width(image->ih));

  glTexImage2D(GL_TEXTURE_2D, 0, ih_image_pixformat(image->ih), 
	       ih_image_width(image->ih),
	       ih_image_height(image->ih),
	       0,	       
	       ih_image_pixformat(image->ih),
	       GL_UNSIGNED_BYTE,
	       ih_image_pixels(image->ih) );

  glColor4f(1.0, 1.0, 1.0, image->opacity);

  glPushMatrix();
  glTranslatef(image->x + image->width / 2,
	       -image->y - image->height / 2,
	       0.0);
  glScalef( image->width, image->height, 1.0);
/*   glRotatef(6.0 * ih_image_frameno(image->ih), */
/* 	    0.0, 0.0, 1.0); */

  {
    glBegin(GL_QUADS);

    glTexCoord2f(0.0, 0.0);
    glVertex2f(-0.5, 0.5);

    glTexCoord2f(ih_image_x_max(image->ih), 0.0);
    glVertex2f(0.5, 0.5);

    glTexCoord2f(ih_image_x_max(image->ih), ih_image_y_max(image->ih));
    glVertex2f(0.5, -0.5);

    glTexCoord2f(0.0, ih_image_y_max(image->ih));
    glVertex2f(-0.5, -0.5);

    glEnd();
  }

  glPopMatrix();

}
