#ifndef PAINT_SERVER_H
#define PAINT_SERVER_H

#include <dtdtc.h>
#include "color.h"

typedef enum {
  SVG_PAINTTYPE_UNKNOWN               = 0,
  SVG_PAINTTYPE_RGBCOLOR              = 1,
  SVG_PAINTTYPE_RGBCOLOR_ICCCOLOR     = 2,
  SVG_PAINTTYPE_NONE                  = 101,
  SVG_PAINTTYPE_CURRENTCOLOR          = 102,
  SVG_PAINTTYPE_URI_NONE              = 103,
  SVG_PAINTTYPE_URI_CURRENTCOLOR      = 104,
  SVG_PAINTTYPE_URI_RGBCOLOR          = 105,
  SVG_PAINTTYPE_URI_RGBCOLOR_ICCCOLOR = 106,
  SVG_PAINTTYPE_URI                   = 107
} svg_painttype_t;

typedef struct svg_paint_server *svg_paint_server_t;

struct svg_paint_server {
  svg_painttype_t paintType;
  struct svg_color color;
};

extern void
svg_paint_server_set(dtdtc_context_t ctx, svg_paint_server_t attribute,
		     xmlChar *value, void *data);

#endif /* PAINT_SERVER_H */
