#include "svg-parser.h"

void
svg_rect_end(dtdtc_context_t ctx) {
  struct svg_element_rect *rect;

  dtdtc_debug(&ctx->error, "");

#if 0
  svg_player_t player = (svg_player_t)ctx->user_data;
#endif

  rect = (struct svg_element_rect*)ctx->element;

  dtdtc_debug(&ctx->error, "%fx%f+%f+%f",
	      rect->width, rect->height, rect->x, rect->y);

  if (rect->fill.paintType == SVG_PAINTTYPE_UNKNOWN)
    dtdtc_attribute_inherit(ctx, ctx->element, "fill",
			    sizeof(struct svg_paint_server));

  if (rect->stroke.paintType == SVG_PAINTTYPE_UNKNOWN)
    dtdtc_attribute_inherit(ctx, ctx->element, "stroke",
			    sizeof(struct svg_paint_server) );

}

void
svg_rect_draw(svg_element_rect_t rect) {

/*   printf("rectangle @(%f,%f,%f,%f) stroke-width=%f\n", */
/* 	 rect->x, -rect->y, rect->x + rect->width, -rect->y - rect->height, */
/* 	 rect->stroke_width); */

  glDisable(GL_TEXTURE_2D);

  glPushMatrix();
  glTranslatef(rect->x + rect->width / 2,
	       -rect->y - rect->height / 2,
	       0.0);
  glScalef(rect->width, rect->height, 1.0);

  /* fill */
  if (rect->fill.paintType == SVG_PAINTTYPE_RGBCOLOR) {
    glColor4f( rect->fill.color.r/255.0, rect->fill.color.g/255.0,
	       rect->fill.color.b/255.0, rect->fill.color.a/255.0);
    glRectf(-0.5, 0.5, 0.5, -0.5);
  }

  /* draw border */
  if (rect->stroke.paintType == SVG_PAINTTYPE_RGBCOLOR) {
    glColor4f( rect->stroke.color.r/255.0, rect->stroke.color.g/255.0,
	       rect->stroke.color.b/255.0, rect->stroke.color.a/255.0 );
    glLineWidth(rect->stroke_width);

    {
      glBegin(GL_LINE_STRIP);
      glVertex2f(-0.5, 0.5);
      glVertex2f(0.5, 0.5);
      glVertex2f(0.5, -0.5);
      glVertex2f(-0.5, -0.5);
      glVertex2f(-0.5, 0.5);
      glEnd();
    }

  }
  glPopMatrix();
}

void
svg_rect_destroy(dtdtc_context_t ctx) {

  dtdtc_debug(&ctx->error, "");

}
