#include <string.h>
#include <ctype.h>
#include "svg-parser.h"

/**
 *
 * parses a css style argument.
 *
 * @value has the production rule:
 * @value := (wsp* <attribute> wsp* : wsp* <value>; wsp*)*
 */
void
svg_style_set(dtdtc_context_t ctx, void *dummy,
	      const dtdtc_string_t style, void *data) {

  dtdtc_string_t str, attribute, value, next;

  str = strdup(style);
  if (!str) {
    dtdtc_warning(ctx, "can't create style");
    return;
  }
  attribute = style;
  while (attribute) {
    while ( *attribute && isspace(*attribute) ) attribute ++;
    if (*attribute) {
      value = attribute + 1;
      while ( *value && *value !=':' && !isspace(*value) ) value ++;
      if (*value) {
	*value = '\0'; value ++;
	while ( *value && isspace(*value) ) value ++;
	if (*value) {
	  next = value + 1;
	  while ( *next && *next != ';' ) next ++;
	  if (*next) {
	    *next = '\0'; next ++;
	  } else {
	    next = NULL;
	  }
	  printf("setting [%s] to [%s]\n", attribute, value);
	  dtdtc_attribute_set(ctx, attribute, value);
	  attribute = next;
	} else {
	  dtdtc_warning(ctx, "can't find value for attribute %s", attribute);
	} 
      } else {
	dtdtc_warning(ctx, "can't find value for attribute %s", attribute);
      }
    }
  }
  free(str);
}
