#include "svg-parser.h"
#include <ctype.h>
#include <errno.h>

/* attribute accessor */

/*
 * set viewport given its xml definition
 */
void 
svg_viewbox_set(dtdtc_context_t ctx,
		svg_viewbox_t attribute,
		const xmlChar *value, void *data) {
  char *tail;

  errno = 0;

  attribute->x_min = strtod(value, &tail);
  while (isspace(*tail) || *tail == ',') tail++;

  attribute->y_min = strtod(tail, &tail);
  while (isspace(*tail) || *tail == ',') tail++;

  attribute->x_max = strtod(tail, &tail);
  while (isspace(*tail) || *tail == ',') tail++;

  attribute->y_max = strtod(tail, &tail);
  while (isspace(*tail) || *tail == ',') tail++;

  if (errno) {
    dtdtc_error(ctx, "invalid viewbox specification: [%s]", value);
  }

  dtdtc_debug(&ctx->error, "viewport set [%f, %f, %f, %f]\n",
	      attribute->x_min, attribute->y_min,
	      attribute->x_max, attribute->y_max);
}
